Description

This patch allows for a plugin to delay loading until a set of requirements is met. This could be because I need for other plugin to be

loaded first.

The ideia is to to have each plugin check at the top of init.rb for it's requirements and if they are not met to raise

Redmine::Plugin::PluginDeferLoadError. This will signal the plugin load logic to try loading this plugin later.

The algorithm prevents infinite looping (by direct or indirect circular dependencies) by loading plugins by iterations. In each iteration

amount of plugins to load must be lower.

The most common check made by plugins can be simplified by using at the top of the init.rb this line:

Redmine::Plugin.requires_plugin('redmine_plugin_name')

 Regards

Related issues:

Related to Redmine - Feature #23131: Plugin load order defined by inter-plugi... Reopened

History

#1 - 2017-07-14 15:40 - Tiago Gonçalves

Relates to:

Defect #6324

Feature #23131

Patch #24939

#2 - 2017-07-17 14:17 - Go MAEDA

- Category set to Plugin API

#3 - 2017-07-17 14:17 - Go MAEDA

- Related to Feature #23131: Plugin load order defined by inter-plugin dependencies added

#4 - 2017-08-11 06:11 - Toshi MARUYAMA

- Description updated

#5 - 2018-12-19 14:40 - Vincent Robert

Hello Tiago

Is this patch compatible with Redmine 4?

I quickly tried it, but I got some errors.

Thank you
